class SizeMatters
  include Comparable
  
  attr :str

  def initialize(str)
    @str = str
  end
  
  def <=>(other)
    str.size <=> other.str.size
  end
  
  def inspect
    @str
  end
  
  def to_s
    "#{@str}, #{@str.size}"
  end
end

s1 = SizeMatters.new("Z")
s1_other = SizeMatters.new('A')
s2 = SizeMatters.new("YY")
s3 = SizeMatters.new("XXX")
s4 = SizeMatters.new("WWWW")
s5 = SizeMatters.new("VVVVV")

puts s1 < s2                       #=> true
puts s1 == s1_other
puts s4.between?(s1, s3)           #=> false
puts s4.between?(s3, s5)           #=> true
puts [ s3, s2, s5, s4, s1 ].sort   #=> [Z, YY, XXX, WWWW, VVVVV]